<?php
/***************************************************************************
 *                         lang_contact_faq.php [English]
 *                            -------------------
 *   begin                : Saturday, May 31, 2003
 *   version              : 1.2.1
 *   copyright            : See readme.txt
 ***************************************************************************/

//	IMPORTANT NOTICE!!
//	This version of lang_contact_faq.php is intended for use when you have installed
//	either Prillian and the expanded version of Contact List or only the expanded
//  version of Contact List. If you are using only Prillian, use the
//	lang_contact_faq.php file provided in that version!

// 
// To add an entry to your FAQ simply add a line to this file in this format:
// $faq[] = array('question', 'answer');
// If you want to separate a section enter
// $faq[] = array('--', 'Block heading goes here if wanted');
// Links will be created automatically
//
// DO NOT forget the ; at the end of the line.
// Do NOT put single quotes (') in your FAQ entries, if you absolutely must then
// escape them i.e.. \'something\' or use double quotes (") at the beginning and end
// of the entries (in which case you'll need to escape any double quotes in the
// entry).
//
// The FAQ items will appear on the FAQ page in the same order they are listed in 
// this file
//
// To mention Contact List by name, use the variable
// $progname as it is used in the defaults
//

include_once($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_contact.' . $phpEx);

$progname = $lang['Contact_List_FAQ'];

$faq[] = array('--', 'General Questions');
$faq[] = array('What are the ' . $progname . '?', $progname . ' are a means by which you can easily find or contact other users or prevent other users from finding or contacting you on this site. The Lists include a Buddy List, an Ignore List, and a Disallow Contact List. A Disallow Contact List is like a lesser version of an Ignore List. It hides your contact information from listed users, but does not erase their presence from your sight like the Ignore List.');
$faq[] = array('How do I edit my ' . $progname . '?', 'To edit your ' . $progname . ', simply access the <a href="' . append_sid(CONTACT_URL) . '">Control Panel</a>.');
$faq[] = array('How can I add a user to my ' . $progname . '?', 'Access the control panel and go to the page for the particular list to which you wish to add a user. Then enter the user\'s username in the form near the bottom of the page and press the Add User button.<br /><br />To add several users at once, access the control panel and click the ' . $lang['Add_contact_users_link'] . ' link. On that page, you can enter several usernames and add them all to your lists at one time.<br /><br />There are also links to add a user to or remove a user from your lists in various places throughout the forum, like user profiles and topics.');

$faq[] = array('--', 'Using your Buddy List');
$faq[] = array('What features does the Buddy List provide?', 'The Buddy List allows you to be alerted when certain users visit or leave the forums while you are logged in and to quickly find their names in certain situations.');
$faq[] = array('How do I choose to be alerted when a buddy comes online?', 'Access the control panel to see your Buddy List. Click the "Edit online and offline alert settings" link. From this page, you can choose to be alerted when certain users come online. Simply check off the users you wish to be alerted about and press the submit button. To stop being alerted about a user, uncheck them and press the submit button.');
$faq[] = array('What is the Buddies button in the private message posting form?', 'You can press this button to open a small window with a list of your buddies. The list lets you quickly see if a buddy is online or offline and click their name to place it in the posting form\'s username field.');
$faq[] = array('What are these ' . $lang['System_title'] . 's?', 'Those are simple notifications that someone has added you to their Buddy List. The messages contain links to that user\'s profile and the Control Panel for your convenience.');

$faq[] = array('--', 'Using your Ignore List');
$faq[] = array('What features does the Ignore List provide?', 'The Ignore List allows you to completely forget about the presence of a user on the forums. It removes that user from your sight and prevents that user from contacting you through the forums.');
$faq[] = array('How are users I ignore removed from my sight?', 'The Ignore List tries to remove all traces of the user on pages when you view them. If you look at a topic containing posts by the ignored user, the posts will not be displayed. Topics that have no replies (or only one reply, if it is also by an ignored user) will not be displayed in the topic list. The user will also not be listed in the member list or lists of users currently online.');
$faq[] = array('What if I want to see the pages with the ignored users?', 'There should be a link somewhere on the page that, when clicked, will allow you to view the unaltered page. The unaltered page should also have a link to reverse the display. These links are only displayed on pages containing content related to users on your Ignore List.');
$faq[] = array('How are users I ignore prevented from contacting me?', 'These users are prevented from seeing some of your contact information in posts, your profile, and the member list. They cannot see your email address or links to send you a private message. Instant Messenger contact information is still displayed. If either private messages or the forum based email system have been enabled, then the ignored users cannot use these systems to send you a message.');

$faq[] = array('--', 'Using your Disallow Contact List');
$faq[] = array('What features does the Disallow Contact List provide?', 'This list makes it harder for annoying users to continue contacting you. It is similar to the ignore list, but does not attempt to remove other users from your sight.');
$faq[] = array('In what ways does it become more difficult for these users to contact me?', 'The users you have added to your Disallow Contact list cannot see any of your contact information in posts, the member list, and your profile. This includes your email address, web site address, instant messenger information, and private message links. The users also are not informed that this information has been hidden from them. As far as they will know, you simply haven\'t entered any such information.<br /><br />If either private messages or the forum based email system have been enabled, then these users also cannot use these systems to send you a message.');

//
// These entries should remain in all languages and for all modifications
//
$faq[] = array('--', $progname . ' Issues');
$faq[] = array('Who wrote this ' . $progname . ' software?', 'This software (in its unmodified form) is produced, released, and is copyrighted by <a href="http://darkmods.sourceforge.net/" target="_blank">Thoul</a>. It is based on and includes some code from the phpBB forum software, which (in its unmodified form) is produced, released, and is copyrighted by <a href="http://www.phpbb.com/" target="_blank">phpBB Group</a>. Both are made available under the GNU General Public License and may be freely distributed; see the links for more details.');
$faq[] = array('Why isn\'t X feature available?', 'This software was written by and licensed through the phpBB Group (in the case of the forum software) and Thoul (in the case of the ' . $progname . ' ). If you believe a feature needs to be added to the instant messenger software then please visit the darkmods.sourceforge.net website and see if anything has been said about it in the forums there. If not, post a feature request in the forums or via the Sourceforge interface.');
$faq[] = array('Whom do I contact about abusive and/or legal matters related to these  ' . $progname . ' ?', 'You should contact the administrator of this board. If you cannot find who that is, you should first contact one of the forum moderators and ask them who you should in turn contact. If still get no response you should contact the owner of the domain (do a whois lookup) or, if this is running on a free service (e.g. yahoo, free.fr, f2s.com, etc.), the management or abuse department of that service. Please note that Thoul has absolutely no control and cannot in any way be held liable over how, where or by whom this board is used. It is absolutely pointless contacting Thoul in relation to any legal (cease and desist, liable, defamatory comment, etc.) matter not directly related to the darkmods.sourceforge.net website or the discrete software of the ' . $progname . ' itself. If you do email Thoul about any third party use of this software then you should not expect a response.');

//
// This ends the FAQ entries
//

?>