<?php
/***************************************************************************
 *                           functions_contact.php
 *                            -------------------
 *   begin                : Sunday, Dec 01, 2002
 *   version              : 0.8.0
 *   copyright            : See readme.txt
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
	die('Hacking attempt');
}

/* popup_buddy_alert($offline, $online)
	Makes a pop-up window that lists buddies who's online or offline status has
	changed recently. $offline is buddies that have gone offline, while $online is
	buddies that have come online.
*/
function popup_buddy_alert($offline, $online)
{
	global $db, $phpbb_root_path, $phpEx, $template, $lang;

	$offline_ids = '';
	$online_ids = '';
	$offline = explode(',', $offline);
	$online = explode(',', $online);

	foreach($offline as $val)
	{
		$offline_ids .= ( ($offline_ids == '') ? '' : ',' ) . intval($val);
	}
	foreach($online as $val)
	{
		$online_ids .= ( ($online_ids == '') ? '' : ',' ) . intval($val);
	}

	$final_list = '';
	if( $offline_ids != '0' )
	{
		$final_list .= $offline_ids;
	}
	if( $online_ids != '0' )
	{
		$final_list .= $online_ids;
	}

	$sql = 'SELECT user_id, username FROM ' . USERS_TABLE . ' WHERE user_id IN (' . $final_list . ')';
	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not get online/offline usernames', '', __LINE__, __FILE__, $sql);
	}
	$rows = $db->sql_fetchrowset($result);

	$offline_names = '';
	$online_names = '';
	$base_url = $phpbb_root_path . 'profile.' . $phpEx . '?mode=viewprofile&u=';
	foreach($rows as $val)
	{
		$temp_url = $base_url . $val['user_id'];
		if( in_array($val['user_id'], $offline) )
		{
			$offline_names .= ( ($offline_names == '') ? '' : ',' ) . '<a href="' . append_sid($temp_url, true) . '" target="profile">' . $val['username'] . '</a>';
		}
		elseif( in_array($val['user_id'], $online) )
		{
			$online_names .= ( ($online_names == '') ? '' : ',' ) . '<a href="' . append_sid($temp_url, true) . '" target="profile">' . $val['username'] . '</a>';
		}
	}

	$offline_str = '';
	$online_str = '';
	if( $offline_ids != '0' )
	{
		$offline_str = ( count($offline) >= 2 ) ? $lang['Buddies_offline'] . ': ' : $lang['Buddy_offline'] . ': ';
	}
	if( $online_ids != '0' )
	{
		$online_str = ( count($online) >= 2 ) ? $lang['Buddies_online'] . ': ' : $lang['Buddy_online'] . ': ';
	}

	$gen_simple_header = true;
	include_once($phpbb_root_path . 'includes/page_header.' . $phpEx);
	$template->set_filenames(array(
		'body' => 'contact/alert_popup.tpl')
	);
	$template->assign_vars(array(
		'L_CLOSE_WINDOW' => $lang['Close_window'],
		'L_BUDDIES_ONLINE' => $online_str,
		'BUDDIES_ONLINE' => $online_names,
		'L_BUDDIES_OFFLINE' => $offline_str,
		'BUDDIES_OFFLINE' => $offline_names
	));
	$template->pparse('body');
	include_once($phpbb_root_path . 'includes/page_tail.' . $phpEx);
}

/* hide_contact_data($mode)
	Sets strings hold user contact information to empty strings. If called as
	hide_contact_data(), then only PM and E-mail info is hidden. If called as
	hide_contact_data('full'), website and IM information also gets hidden.
*/
function hide_contact_data($mode = 'part')
{
	global $pm_img, $pm, $email_img, $email;
	$pm_img = $pm = $email_img = $email = '';
	if( $mode == 'full' )
	{
		global $www_img, $www, $icq_status_img, $icq_img;
		global $icq, $aim_img, $aim, $msn_img, $msn, $yim_img, $yim;
		$www_img = $www = $icq_status_img = $icq_img = '';
		$icq = $aim_img = $aim = $msn_img = $msn = $yim_img = $yim = '';
	}
	
}

/* check_contact_data($user_id, $viewer_id)
	Checks to see if a viewer is on a user's ignore or disallow list. If so,
	hide_contact_data is used to remove appropriate contact information.
	Used in	viewtopic.php, usercp_viewprofile.php, and memberlist.php.
	When $viewer_id is used in function call, an SQL query is performed to check
	the viewer's status.
*/
function check_contact_data($user_id, $viewer_id = '')
{
	global $contact_list;

	if( defined('NO_CONTACTS') )
	{
		return; // Quit if there is no contact list info on current page
	}

	if( $viewer_id != '' )
	{
		if( $contact_list->check_user($user_id, $viewer_id, 'disallow') )
		{
			hide_contact_data('full');
		}
		elseif( $contact_list->check_user($user_id, $viewer_id, 'ignore') )
		{
			hide_contact_data();
		}
	}
	else
	{
		if( array_key_exists($user_id, $contact_list->disallow_by) )
		{
			hide_contact_data('full');
		}
		elseif( array_key_exists($user_id, $contact_list->ignored_by) )
		{
			hide_contact_data();
		}
	}
}

/* make_ignore_msg($have_ignored, $ignore_users, $baseurl, $mode)
	Creates links to switch between viewing a page with ignored user information
	and without.
	$have_ignored - indicates whether the page has some ignored info on it
	$ignore_users - indicates whether or not the "don't ignore" link was clicked
	$baseurl - URL of the current page, without append_sid()
*/
function make_ignore_msg($have_ignored, $ignore_users, $baseurl)
{
	if( defined('NO_CONTACTS') )
	{
		return; // Quit if there is no contact list info on current page
	}

	global $ignored_msg, $lang, $template;

	if ( $have_ignored )
	{
		$ignored_msg = $lang['Ignored_some_users'];
		$baseurl .= '&amp;no_ignore=1';
	}
	elseif( !$ignore_users && !$have_ignored )
	{
		$ignored_msg = $lang['Ignore_some_users'];
	}

	if( !empty($ignored_msg) )
	{
		$ignored_msg = sprintf($ignored_msg, append_sid($baseurl));
	}

	$template->assign_vars(array('IGNORED_MSG' => $ignored_msg));
}

/* check_quotes($message, $bbcode_uid, $baseurl, $contact_list)
	Parses a message to see if it contains quotes attributed to an ignored user.
	This must be called before BBCode is parsed to display a message, but after
	HTML is replaced (e.g., when HTML is off in the post/board).
*/
function check_quotes(&$message, $bbcode_uid, $baseurl, $contact_list, $ignore_users)
{
	// First, see if we are in non-ignoring mode or have anything to replace
	if( empty($contact_list->quote_checks) || !$ignore_users )
	{
		return; // We have nothing to deal with here.
	}

	// Next, check to see if there are any username quotes in the message.
	if( strpos($message, '[quote:' . $bbcode_uid . '="') === FALSE )
	{
		return; // We have nothing to deal with here.
	}

	// If we're here, we need to run through the reg exps...
	if( !replace_quotes($contact_list->quote_checks, $bbcode_uid, $message) )
	{
		return;
	}

	// By now, we've removed some quotes that were ignored.
	global $lang;

	$replace_string = '[quote:' . $bbcode_uid . ']' . sprintf($lang['Ignored_quote'], append_sid($baseurl . '&amp;no_ignore=1')) . '[/quote:' . $bbcode_uid . ']';
	$message = $replace_string . "\n" . $message;
}

/* replace_quotes($usernames, $bbcode_uid, $message, $contact_list)
	Attempts to look through a message and find all the quotes to be ignored, nested
	or otherwise, inside that message. The quotes are then replaced with an empty
	string.
*/
function replace_quotes($usernames, $bbcode_uid, &$message)
{
	$pattern = '#\[quote\:' . $bbcode_uid . '="' . $usernames . '"\](.*?)\[/quote\:' . $bbcode_uid . '\]#si';
	$matches = array();

	if( !preg_match_all($pattern, $message, $matches) )
	{
		return false; // No quotes of ignored users in the message.
	}

	// If we get this far, there are some quotes to ignore. Now we need to check
	// the body of them for nested quotes. Our match above will have only found
	// the first [/quote] following a [quote="name"] - we need more [/quote]'s
	// if there are any quotes inside the one we're trying to ignore.
	$replaced = false;
	$search_key = '[/quote:' . $bbcode_uid . ']';
	$key_length = strlen($search_key);
	foreach($matches[1] as $k=>$v)
	{
		$start_pos = strpos($message, $matches[0][$k]);
		$final_pos = strlen($matches[0][$k]);
		$pos = strpos($v, '[quote:' . $bbcode_uid);
		if( $pos === FALSE )
		{
			$message = substr_replace($message, '', $start_pos, $final_pos);
			$replaced = true;
			$message = replace_newlines($message, $start_pos);
		}
		else
		{
			// There are nested quotes, so let's find the matching [/quote] tags for
			// the opening quote tags in our string. Then we'll have the starting
			// and ending positions of the quote to replace.
			$num_of_open_quotes = substr_count($v, '[quote:' . $bbcode_uid);
			$next_pos = $final_pos = $start_pos + $final_pos;
			for($i=0; $i < $num_of_open_quotes ; $i++)
			{
				$next_pos = strpos($message, $search_key, $final_pos);
				if( $next_pos !== FALSE )
				{
					$final_pos = $next_pos + $key_length;
				}
			}
			$final_pos = $final_pos - $start_pos;
			$message = substr_replace($message, '', $start_pos, $final_pos);
			$message = replace_newlines($message, $start_pos);
			$replaced = true;
		}
	}

	return $replaced;
}

/* replace_newlines($message, $position)
	Remove quote blocks from a message can result in extra spacing if there were
	newlines before and after it. This function is used to convert a two newlines
	separated by a space character into a single newline.
*/
function replace_newlines($message, $position)
{
	--$position;
	if( preg_match("#\n\s\n#", substr($message, $position, 3)) )
	{
		$message = substr_replace($message, "\n", $position, 3);
	}
	return $message;
}

/* assign_cl_images('tpl_block', $contact_result)
	Assigns a template class block used to display add/remove user links and
	variables for that block.
*/
function assign_cl_images($block_name, $contact_result)
{
	if( !$contact_result )
	{
		return;
	}

	global $template;

	$template->assign_block_vars($block_name, array(
		'IMG_BUDDY' => $contact_result['img_buddy'],
		'IMG_IGNORE' => $contact_result['img_ignore'],
		'IMG_DISALLOW' => $contact_result['img_disallow'],
		'L_ALT_BUDDY' => $contact_result['l_buddy_alt'],
		'L_ALT_IGNORE' => $contact_result['l_ignore_alt'],
		'L_ALT_DISALLOW' => $contact_result['l_disallow_alt'],
		'U_BUDDY' => $contact_result['final_buddy_url'],
		'U_IGNORE' => $contact_result['final_ignore_url'],
		'U_DISALLOW' => $contact_result['final_disallow_url']
	));
}
?>