<?php
/***************************************************************************
 *                            contact_install.php
 *                            -------------------
 *   begin                : Monday, Nov 11, 2002
 *   version              : 3.1.3
 *   copyright            : See readme.txt
 ***************************************************************************/

/* This is an script to install Contact List, based off phpBB install scripts. This
   script requires a successful installation of phpBB to already exist. If you're
   including Contact List in a premodded board package and looking to add this to
   your installer, keep that in mind.
*/
$phpbb_root_path='./../';
include_once($phpbb_root_path . 'hack_install/contact_insfunc.php');

$mode = ( $_REQUEST['mode'] == 'new' || $_REQUEST['mode'] == 'delete' ) ? $_REQUEST['mode']: '';

function make_db_changes(&$message, &$error, $type)
{
	global $db, $table_prefix;
	global $dbms_schema, $dbms_basic, $dbms_alter, $remove_remarks, $delimiter, $delimiter_basic;

	switch($type)
	{
		case 'delete':
		case 'schema':
			$breaker = $delimiter;
			$sourcefile = $dbms_schema;
			$message .= '<span class="head_msg">Attempting to read Schema SQL file:</span> ';
			$msg1 = '<span class="head_msg">Attempting to create new DB tables:</span><br />';
			$msg_type = 'Table';
			$msg_succ = 'created';
			break;
		case 'data':
			$breaker = $delimiter_basic;
			$sourcefile = $dbms_basic;
			$message .= '<span class="head_msg">Attempting to read Data SQL file:</span> ';
			$msg1 = '<span class="head_msg">Attempting to add new data:</span><br />';
			$msg_type = 'Query';
			$msg_succ = 'completed';
			break;
		case 'alter_delete':
			$type = 'delete';
		case 'alter':
			$breaker = $delimiter;
			$sourcefile = $dbms_alter;
			$message .= '<span class="head_msg">Attempting to read Table Alter SQL file:</span> ';
			$msg1 = '<span class="head_msg">Attempting to alter DB tables:</span><br />';
			$msg_type = 'Table Alterations';
			$msg_succ = 'completed';
			break;
		default:
			$message .= '<span class="err_msg">Could not determine what to do!</span>';
			return;
			break;
	}

	$sql_query = get_schema($sourcefile, $breaker);

	if( $type == 'delete' )
	{
		return $sql_query;
	}

	if( $queries_size = sizeof($sql_query) )
	{
		$message .= '<span class="success_msg">Successful!</span><br /><br />';
	}
	else
	{
		$error = true;
		$message .= '<span class="err_msg">Failed!</span><br /><br />';
		return;
	}

	$message .= $msg1;
	for ($i = 0; $i < $queries_size; $i++)
	{
		if (trim($sql_query[$i]) != '')
		{
			$message .= '&nbsp;&nbsp;&nbsp;&nbsp;<span class="query_msg">' . $sql_query[$i] . '</span><br />&nbsp; &nbsp; &nbsp; &nbsp; ';
			if ( !($result = $db->sql_query($sql_query[$i])) )
			{
				$error = true;
				$error_msg = $db->sql_error();
				$message .= '<span class="err_msg">' . $msg_type . ' ' . ($i+1) . ' Failed! Error message follows:<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;' . $error_msg['message'] . '</span><br /><br />';
			}
			else
			{
				$message .= '<span class="success_msg">' . $msg_type . ' ' . ($i+1) . ' successfully ' . $msg_succ . '!</span><br /><br />';
			}
		}
	}
}

function del_thoul_tables(&$message, $type)
{
	global $db, $table_prefix, $phpbb_root_path, $phpEx;
	
	$error = false;

	// Parse the MySQL schema file into some arrays.
	setup_db_data();
	$sql_query = make_db_changes($message, $error, $type);

	if( $queries_size = sizeof($sql_query) )
	{
		$message .= '<span class="success_msg">Successful!</span><br /><br />';
	}
	else
	{
		$error = true;
		$message .= '<span class="err_msg">Failed!</span><br /><br />';
		return;
	}

	if( $type == 'delete' )
	{
		$message .= '<span class="head_msg">Attempting to delete DB tables:</span><br />';
		$msg1 .= 'deletion';
	}
	else
	{
		$message .= '<span class="head_msg">Attempting to delete alterations to DB tables:</span><br />';
		$msg1 .= 'alteration';
	}

	for($ii=0; $ii<$queries_size; $ii++)
	{
		$delete_query = '';
		if( $type == 'delete' )
		{
			if ( preg_match('/^CREATE TABLE (\w+)/i', trim($sql_query[$ii]), $matches[$ii]) )
			{
				$delete_query = 'DROP TABLE ' . $matches[$ii][1];
			}
			else
			{
				$error = true;
				continue;
			}
		}
		else
		{
			if ( preg_match('/^ALTER TABLE (\w+) ADD (\w+)/i', trim($sql_query[$ii]), $matches[$ii]) )
			{
				if( $matches[$ii][2] != 'INDEX' )
				{
					$delete_query = 'ALTER TABLE ' . $matches[$ii][1] . ' DROP ' . $matches[$ii][2];
				}
				else
				{
					continue;
				}
			}
			else
			{
				$error = true;
				continue;
			}
		}

		$message .= '&nbsp;&nbsp;&nbsp;&nbsp;';

		if( !$db->sql_query($delete_query) )
		{
			$error = true;
			$error_msg = $db->sql_error();
			$message .= '<span class="err_msg">Table ' . $msg1 . ' ' . $ii . ' Failed! Error message follows:<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $error_msg['message'] . '</span><br /><br />';
		}
	}

	if( !$error )
	{
		$message .= '<span class="success_msg">Successful!</span><br /><br />';
	}
}

function new_install()
{
	global $phpbb_root_path, $board_config, $table_prefix, $db, $current_version, $phpEx, $act_level, $echo_name;

	$error = false;

	$message = '<div class="step">';

	switch($act_level)
	{
		case '1':
			// Install new DB tables
			$message .= 'This is step 1 out of 3!</div>
				<div class="mainbody">
					We will now try to install new database tables.<br /><br />';

			// We're going to need the sql parser
			include_once($phpbb_root_path . 'includes/sql_parse.' . $phpEx);
			setup_db_data();
			make_db_changes($message, $error, 'schema');
			if( $error )
			{
				$message .= '<br />Oh no, there was an error! If any of these tables were not created and did not already exist, then you may have to perform the queries in the *_im_schema.sql file for your database type manually. Here are some things to look out for in an error on this step:<ul><li><span class="bold">Error: Attempting to read Schema SQL file: Failed!</span><br />Make sure the *.sql files are in the same directory as contact_install.php!</li><li>Error: Table \'' . $table_prefix . 'contact_list\' already exists<br />If you have already installed Thoul\'s Prillian hack, do not worry about this. Both Contact List and Prillian attempt to create this table on installation. As long as one of them does so, you\'re fine.</li></ul>';
			}
			else
			{
				$message .= '<br /><span class="bold">No errors detected in this step.</span>';
			}
			break;
		case '2':
			// Add new config vars
			$message .= 'This is step 2 out of 3!</div>
				<div class="mainbody">
					We will now try to add the version number to the configuration table.<br /><br />';
			include_once($phpbb_root_path . 'includes/sql_parse.' . $phpEx);
			setup_db_data();
			make_db_changes($message, $error, 'data');
			if( $error )
			{
				$message .= '<br />Oh no, there was an error! If this query was not successfully completed and did not already exist, then there may be a problem upgrading to the next version later! Here are some things to look out for in an error on this step:<ul><li><span class="bold">Error: Attempting to read Data SQL file: Failed!</span><br />Make sure the *.sql files are in the same directory as im_install.php!</li><li><span class="bold">Duplicate entry errors</span><br />This error message means the data in that particular query has been added to your tables previously. Generally, this is not an error to worry about and you can ignore it.</li></ul>';
			}
			else
			{
				$message .= '<br /><span class="bold">No errors detected in this step.</span>';
			}
			break;
		case '3':
			// Finished.
			$message .= '</div>
				<div class="mainbody">
					Congratulations, you have finished the Contact List installation!<br /><br />If you encountered no error messages, then your next step should be to upload any Contact List files or modified phpBB files that you have not already uploaded.<br /><br />If you did encounter an error, then you may need to do some manual modifications to your database through another utility.<br /><br />Please remember to delete the Contact List installer files.';
			break;
		default:
			$message .= 'This is step 0 out of 3!</div>
				<div class="mainbody">Okay, you chose to install Contact List! The installation will be done in several steps so that you can see what this script will attempt to install and any errors that may occur. When a step of the installation is completed, you can proceed to the next step by clicking the Proceed to Next Step link. As you proceed, some tips and advice on common errors that you may encounter will be displayed.<br /><br />Proceed to the Next Step to begin installing Contact List!';
			break;
	}			

	if( $act_level != 3  )
	{
		$message .= '</div>
			<div class="proceed"><a href="contact_install.php?mode=new&act_level=' . ++$act_level . '">Proceed to Next Step &gt;&gt;</a>';
	}
		
	$message .= '</div>';
	echo $message;
}


function delete_install()
{
	global $phpbb_root_path, $db, $board_config, $current_version, $phpEx;

	// We're going to need the sql parser
	include_once($phpbb_root_path.'includes/sql_parse.'.$phpEx);

	$message = '<div class="mainbody">Okay, if you\'re sure you want to delete Contact List, let\'s do it.<br /><br />';

	del_thoul_tables($message, 'delete');

	// Data Removal
	$message .= '<span class="head_msg">Attempting to delete Config entries:</span><br />';

	$sql = 'DELETE FROM ' . CONFIG_TABLE . " WHERE config_name LIKE 'contqct_%'";
	
	if( !$db->sql_query($sql) )
	{
		$message .= '<span class="err_msg">Failed!</span><br /><br />';
	}
	else
	{
		$message .= '<span class="success_msg">Successful!</span><br /><br />';
	}
	$message .= '</div>';
	echo $message;
}

function choose_install()
{
	global $phpEx, $echo_name;
	$message = '<div class="mainbody">Before proceeding, please ensure that you have uploaded the ' . $echo_name . ' new phpBB files and your edited constants.' . $phpEx . ' file. If these files are not uploaded, you may not be able to use this installer correctly.<br /><br />Please choose an installation method:<ul><li><a href="contact_install.' . $phpEx . '?mode=new">New ' . $echo_name . ' Installation</a></li><!-- li><a href="contact_upgrade.' . $phpEx . '">Upgrade From A Previous Installation</a></li --><li><a href="contact_install.' . $phpEx . '?mode=delete">Uninstall ' . $echo_name . ' Database Changes</a></li></ul></div>';
	echo $message;
}

function confirm_delete()
{
	global $phpEx, $echo_name;

	$message = '<div class="mainbody">You have chosen to uninstall the ' . $echo_name . ' database changes. This will make ' . $echo_name . ' unusable, so you should remove the changes to original phpBB files (except for constants.php) first to prevent your forum from breaking. You should also backup your database tables in case of errors. If you have done that and are certain you wish to remove the database changes, click the link below.<ul><li><a href="contact_install.' . $phpEx . '?mode=delete&confirm=1">Uninstall database changes</a></li></ul></div>';
	echo $message;
}


// Page Output
page_header();

switch($mode)
{
	case 'new':
		if( $board_config['contact_version'] >= $current_version && !$act_level )
		{
			$message = '<div class="mainbody"><span class="err_msg">You have already installed ' . $echo_name . ' or a later version.</span></div>';
			echo $message;
		}
		else
		{
			new_install();
		}
		break;
	case 'delete':
		if( isset($_REQUEST['confirm']) )
		{
			delete_install();
		}
		else
		{
			confirm_delete();
		}
		break;
	case '':
	default:
		choose_install();
		break;
}
page_footer();

?>